# tickforge-client
An API to interact with Uptick Internal Resources

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 2.1.0
- Generator version: 7.14.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import tickforge_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import tickforge_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import tickforge_client
from tickforge_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://tickforge.onuptick.com
# See configuration.py for a list of all supported configuration parameters.
configuration = tickforge_client.Configuration(
    host = "https://tickforge.onuptick.com"
)



# Enter a context with an instance of the API client
with tickforge_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = tickforge_client.AuthApi(api_client)
    code = 'code_example' # str | 
    state = 'state_example' # str | 

    try:
        # Cognito Callback
        api_response = api_instance.cognito_callback_api_auth_cognito_callback_get(code, state)
        print("The response of AuthApi->cognito_callback_api_auth_cognito_callback_get:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AuthApi->cognito_callback_api_auth_cognito_callback_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://tickforge.onuptick.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AuthApi* | [**cognito_callback_api_auth_cognito_callback_get**](docs/AuthApi.md#cognito_callback_api_auth_cognito_callback_get) | **GET** /api/auth/cognito_callback | Cognito Callback
*AuthApi* | [**login_for_access_token_api_auth_token_post**](docs/AuthApi.md#login_for_access_token_api_auth_token_post) | **POST** /api/auth/token | Login For Access Token
*AuthApi* | [**me_api_auth_me_get**](docs/AuthApi.md#me_api_auth_me_get) | **GET** /api/auth/me | Me
*BuildsApi* | [**create_build_api_builds_post**](docs/BuildsApi.md#create_build_api_builds_post) | **POST** /api/builds/ | Create Build
*DbApi* | [**copy_db_api_db_copy_post**](docs/DbApi.md#copy_db_api_db_copy_post) | **POST** /api/db/copy | Copy Db
*DefaultApi* | [**health_check_healthz_get**](docs/DefaultApi.md#health_check_healthz_get) | **GET** /healthz | Health Check
*DefaultApi* | [**health_check_livez_get**](docs/DefaultApi.md#health_check_livez_get) | **GET** /livez | Health Check
*DefaultApi* | [**health_check_readyz_get**](docs/DefaultApi.md#health_check_readyz_get) | **GET** /readyz | Health Check
*GitApi* | [**refresh_respository_api_git_refresh_repository_post**](docs/GitApi.md#refresh_respository_api_git_refresh_repository_post) | **POST** /api/git/refresh_repository | Refresh Respository
*GitApi* | [**versions_config_api_git_versions_get**](docs/GitApi.md#versions_config_api_git_versions_get) | **GET** /api/git/versions | Versions Config
*GithubApi* | [**workflow_job_webhook_api_github_webhooks_workflow_job_post**](docs/GithubApi.md#workflow_job_webhook_api_github_webhooks_workflow_job_post) | **POST** /api/github/webhooks/workflow_job | Workflow Job Webhook
*JobsApi* | [**get_job_api_jobs_job_id_get**](docs/JobsApi.md#get_job_api_jobs_job_id_get) | **GET** /api/jobs/{job_id} | Get Job
*MetricsApi* | [**create_metric_api_metrics_post**](docs/MetricsApi.md#create_metric_api_metrics_post) | **POST** /api/metrics/ | Create Metric
*MetricsApi* | [**create_metric_blob_api_metrics_blob_post**](docs/MetricsApi.md#create_metric_blob_api_metrics_blob_post) | **POST** /api/metrics/blob | Create Metric Blob
*MetricsApi* | [**get_metric_api_metrics_get**](docs/MetricsApi.md#get_metric_api_metrics_get) | **GET** /api/metrics/ | Get Metric
*MetricsApi* | [**get_metric_blob_api_metrics_blob_get**](docs/MetricsApi.md#get_metric_blob_api_metrics_blob_get) | **GET** /api/metrics/blob | Get Metric Blob
*RedirectsApi* | [**me_redirect_me_get**](docs/RedirectsApi.md#me_redirect_me_get) | **GET** /me | Me Redirect
*RedirectsApi* | [**refresh_repository_redirect_api_refresh_repository_post**](docs/RedirectsApi.md#refresh_repository_redirect_api_refresh_repository_post) | **POST** /api/refresh_repository | Refresh Repository Redirect
*RedirectsApi* | [**token_redirect_token_post**](docs/RedirectsApi.md#token_redirect_token_post) | **POST** /token | Token Redirect
*RedirectsApi* | [**versions_redirect_api_versions_get**](docs/RedirectsApi.md#versions_redirect_api_versions_get) | **GET** /api/versions | Versions Redirect
*SlackApi* | [**search_users_api_slack_search_get**](docs/SlackApi.md#search_users_api_slack_search_get) | **GET** /api/slack/search | Search Users
*WorkspacesApi* | [**bump_api_workspaces_bump_post**](docs/WorkspacesApi.md#bump_api_workspaces_bump_post) | **POST** /api/workspaces/bump | Bump
*WorkspacesApi* | [**bump_app_api_workspaces_app_name_bump_post**](docs/WorkspacesApi.md#bump_app_api_workspaces_app_name_bump_post) | **POST** /api/workspaces/{app_name}/bump | Bump App
*WorkspacesApi* | [**create_backup_api_workspaces_workspace_name_backups_post**](docs/WorkspacesApi.md#create_backup_api_workspaces_workspace_name_backups_post) | **POST** /api/workspaces/{workspace_name}/backups | Create Backup
*WorkspacesApi* | [**create_workspace_api_workspaces_create_post**](docs/WorkspacesApi.md#create_workspace_api_workspaces_create_post) | **POST** /api/workspaces/create | Create Workspace
*WorkspacesApi* | [**create_workspace_api_workspaces_post**](docs/WorkspacesApi.md#create_workspace_api_workspaces_post) | **POST** /api/workspaces/ | Create Workspace
*WorkspacesApi* | [**list_backups_api_workspaces_workspace_name_backups_get**](docs/WorkspacesApi.md#list_backups_api_workspaces_workspace_name_backups_get) | **GET** /api/workspaces/{workspace_name}/backups | List Backups
*WorkspacesApi* | [**list_workspaces_api_workspaces_get**](docs/WorkspacesApi.md#list_workspaces_api_workspaces_get) | **GET** /api/workspaces/ | List Workspaces
*WorkspacesApi* | [**qadeploy_api_workspaces_qadeploy_post**](docs/WorkspacesApi.md#qadeploy_api_workspaces_qadeploy_post) | **POST** /api/workspaces/qadeploy | Qadeploy
*WorkspacesApi* | [**qadestroy_api_workspaces_qadestroy_post**](docs/WorkspacesApi.md#qadestroy_api_workspaces_qadestroy_post) | **POST** /api/workspaces/qadestroy | Qadestroy
*WorkspacesApi* | [**suspend_workspace_api_workspaces_workspace_name_suspend_post**](docs/WorkspacesApi.md#suspend_workspace_api_workspaces_workspace_name_suspend_post) | **POST** /api/workspaces/{workspace_name}/suspend | Suspend Workspace


## Documentation For Models

 - [Backup](docs/Backup.md)
 - [BaseUser](docs/BaseUser.md)
 - [BodyBumpApiWorkspacesBumpPost](docs/BodyBumpApiWorkspacesBumpPost.md)
 - [BodyBumpAppApiWorkspacesAppNameBumpPost](docs/BodyBumpAppApiWorkspacesAppNameBumpPost.md)
 - [BodyQadeployApiWorkspacesQadeployPost](docs/BodyQadeployApiWorkspacesQadeployPost.md)
 - [BodyQadestroyApiWorkspacesQadestroyPost](docs/BodyQadestroyApiWorkspacesQadestroyPost.md)
 - [BuildSchema](docs/BuildSchema.md)
 - [Cluster](docs/Cluster.md)
 - [CodeMetricBlobPayload](docs/CodeMetricBlobPayload.md)
 - [CodeMetricBlobResponse](docs/CodeMetricBlobResponse.md)
 - [CopyDBPayload](docs/CopyDBPayload.md)
 - [CreateBackupResponse](docs/CreateBackupResponse.md)
 - [CreateBuildPayload](docs/CreateBuildPayload.md)
 - [CreateMetricPayload](docs/CreateMetricPayload.md)
 - [CreateWorkspacePayload](docs/CreateWorkspacePayload.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [Job](docs/Job.md)
 - [JobStatus](docs/JobStatus.md)
 - [ListUserResponse](docs/ListUserResponse.md)
 - [Metric](docs/Metric.md)
 - [Profile](docs/Profile.md)
 - [ResponseMetadata](docs/ResponseMetadata.md)
 - [ServerTimezone](docs/ServerTimezone.md)
 - [ServerType](docs/ServerType.md)
 - [Size](docs/Size.md)
 - [SlackMember](docs/SlackMember.md)
 - [TokenResponse](docs/TokenResponse.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)
 - [VersionsConfig](docs/VersionsConfig.md)
 - [Workspace](docs/Workspace.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="HTTPBearer"></a>
### HTTPBearer

- **Type**: Bearer authentication


## Author




